<template>
  <h1>I18n</h1>

  <rui-tabs>
    <rui-button :active="tab === 'text'" caption="Introduction" @click="tab = 'text'" />
    <rui-button :active="tab === 'references'" caption="References" @click="tab = 'references'" />
  </rui-tabs>

  <doc-markdown-renderer v-show="tab==='text'" file="I18n" document />

  <div v-show="tab==='references'">
    <div class="_filters">
      <div class="_filters__section">
        <label for="selected_locale" class="_filters__section__title">Locale</label>
        <select id="selected_locale" v-model="selectedLocale">
          <option v-for="key in Object.keys(locales)" :key="key" :value="key">{{ key }}</option>
        </select>
      </div>

      <div class="_filters__section">
        <div class="_filters__section__title">Format</div>
        <rui-toolbar>
          <rui-button caption="Table" :active="localesDisplay === 'table'" @click="localesDisplay = 'table'" />
          <rui-button caption="Javascript" :active="localesDisplay === 'js'" @click="localesDisplay = 'js'" />
          <rui-button caption="YAML" :active="localesDisplay === 'yaml'" @click="localesDisplay = 'yaml'" />
        </rui-toolbar>
      </div>
    </div>

    <table v-show="localesDisplay === 'table'">
      <thead>
        <tr>
          <th>Key</th>
          <th>Value</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="key in Object.keys(selectedLocaleMessages).sort()" :key="key">
          <td>
            <span class="-inline-flex -gap">
              <doc-copy-to-clipboard :content="key" class="rui-button--small" />
              <code>{{ key }}</code>
            </span>
          </td>
          <td>{{ selectedLocaleMessages[key] }}</td>
        </tr>
      </tbody>
    </table>
    <template v-if="localesDisplay === 'js'">
      <rui-loading v-if="!selectedLocaleSource.js" text="Loading file..." />
      <doc-code-block-renderer v-else language="js" :source="selectedLocaleSource.js" />
    </template>
    <template v-else-if="localesDisplay === 'yaml'">
      <doc-code-block-renderer language="yaml" :source="selectedLocaleSource.yaml" />

      <p>For Ruby on Rails, copy/paste content in <code>config/locales/rui.{{ selectedLocale }}.yml</code></p>
    </template>
  </div>
</template>

<script>
import YAML from 'json-to-pretty-yaml'

import locales from '../../../src/locales'
import { flattenDict } from '../../../documentation_system/utils/Object.js'

import { DocMarkdownRenderer, DocCopyToClipboard, DocCodeBlockRenderer } from '../../../documentation_system/components/index.js'

export default {
  name: 'I18nView',
  components: { DocCodeBlockRenderer, DocCopyToClipboard, DocMarkdownRenderer },
  data () {
    return {
      tab: 'text',
      localesDisplay: 'table',
      locales,
      selectedLocale: 'en',
      localesFiles: {},
    }
  },
  computed: {
    selectedLocaleSource () { return this.localesFiles[this.selectedLocale] },
    selectedLocaleMessages () { return flattenDict(this.locales[this.selectedLocale]) },
  },
  created () {
    this.$setTitle('I18n')

    Object.keys(this.locales).forEach((key) => {
      import(`../../../src/locales/${key}.js?raw`).then((data) => {
        this.localesFiles[key] = {
          js: data.default,
          yaml: YAML.stringify(locales[key]),
        }
      })
    })
  },
}
</script>
